package com.tu.Security;

import java.security.KeyFactory;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.Signature;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;

import javax.crypto.Cipher;

import org.apache.commons.codec.binary.Base64;
import org.apache.commons.codec.binary.Hex;

/**
 * <pre>
 * 数字签名算法-RSA
 * 经典算法 
 * MD,SHA两类
 * 
 * 算法:
 * MD2withRSA       实现方: JDK
 * MD5withRSA       实现方: JDK
 * SHA1withRSA      实现方: JDK
 * SHA224withRSA    实现方: BC
 * SHA256withRSA    实现方: BC
 * SHA384withRSA    实现方: BC
 * SHA512withRSA    实现方: BC
 * RIPEMD128withRSA 实现方: BC
 * RIPEMD160withRSA 实现方: BC
 * 
 * 
 * 非对称加密算法-RSA
 * 唯一广泛接受并实现
 * 数据加密&数字签名
 * 公钥加密,私钥解密
 * 私钥加密,公钥解密
 * 
 * JDK 密钥长度:512~65536(64整数倍) 工作模式:ECB 默认长度:1024 填充方式: 
 * NoPadding
 * PKCS1Padding
 * OAEPWITHMD5AndMGF1Pading
 * OAEPWITHSHA1AndMGF1Pading
 * OAEPWITHSHA256AndMGF1Pading
 * OAEPWITHSHA384AndMGF1Pading
 * OAEPWITHSHA512AndMGF1Pading
 * 
 * BC 密钥长度:512~65536(64整数倍) 工作模式:NONE 默认长度:2048 填充方式: 
 * NoPadding
 * PKCS1Padding
 * OAEPWITHMD5AndMGF1Pading
 * OAEPWITHSHA1AndMGF1Pading
 * OAEPWITHSHA224AndMGF1Pading
 * OAEPWITHSHA256AndMGF1Pading
 * OAEPWITHSHA384AndMGF1Pading
 * OAEPWITHSHA512AndMGF1Pading
 * ISO9796-1Padding
 * 
 * </pre>
 * 
 * @author comtu
 */
public class RSA {
	public static void main(String[] args) {
		jdkRSA("comtu");
		jdkRSA2("comtu");
	}

	public static void jdkRSA(String msg) {
		try {
			// 1.初始化密钥
			KeyPairGenerator keyPairGenerator = KeyPairGenerator.getInstance("RSA");
			keyPairGenerator.initialize(512);
			KeyPair keyPair = keyPairGenerator.generateKeyPair();
			RSAPublicKey rsaPublicKey = (RSAPublicKey) keyPair.getPublic();
			RSAPrivateKey rsaPrivateKey = (RSAPrivateKey) keyPair.getPrivate();

			// 2.执行签名
			PKCS8EncodedKeySpec pkcs8EncodedKeySpec = new PKCS8EncodedKeySpec(rsaPrivateKey.getEncoded());
			KeyFactory keyFactory = KeyFactory.getInstance("RSA");
			PrivateKey privateKey = keyFactory.generatePrivate(pkcs8EncodedKeySpec);
			Signature signature = Signature.getInstance("MD5withRSA");
			signature.initSign(privateKey);
			signature.update(msg.getBytes());
			byte[] result = signature.sign();
			System.out.println("jdk rsa sign: "+Hex.encodeHexString(result));
			
			//3.验证签名
			X509EncodedKeySpec x509EncodedKeySpec = new X509EncodedKeySpec(rsaPublicKey.getEncoded());
			keyFactory = KeyFactory.getInstance("RSA");
			PublicKey publicKey = keyFactory.generatePublic(x509EncodedKeySpec);
			signature = Signature.getInstance("MD5withRSA");
			signature.initVerify(publicKey);
			signature.update(msg.getBytes());
			boolean bool = signature.verify(result);
			System.out.println("jdk rea verify:"+bool);
		} catch (Exception e) {
		}
	}
	
	public static void jdkRSA2(String src){
		try {
			//1.初始化密钥
			KeyPairGenerator keyPairGenerator = KeyPairGenerator.getInstance("RSA");
			keyPairGenerator.initialize(512);
			KeyPair keyPair = keyPairGenerator.generateKeyPair();
			RSAPublicKey rsaPublicKey = (RSAPublicKey)keyPair.getPublic();
			RSAPrivateKey rsaPrivateKey = (RSAPrivateKey)keyPair.getPrivate();
			System.out.println("Public Key : " + Base64.encodeBase64String(rsaPublicKey.getEncoded())); 
			System.out.println("Private Key : " + Base64.encodeBase64String(rsaPrivateKey.getEncoded())); 
			
			//2.私钥加密、公钥解密——加密
			PKCS8EncodedKeySpec pkcs8EncodedKeySpec = new PKCS8EncodedKeySpec(rsaPrivateKey.getEncoded());
			KeyFactory keyFactory = KeyFactory.getInstance("RSA");
			PrivateKey privateKey = keyFactory.generatePrivate(pkcs8EncodedKeySpec);
			Cipher cipher = Cipher.getInstance("RSA");
			cipher.init(Cipher.ENCRYPT_MODE, privateKey);
			byte[] result = cipher.doFinal(src.getBytes());
			System.out.println("私钥加密、公钥解密——加密 : " + Base64.encodeBase64String(result));
			
			//3.私钥加密、公钥解密——解密
			X509EncodedKeySpec x509EncodedKeySpec = new X509EncodedKeySpec(rsaPublicKey.getEncoded());
			keyFactory = KeyFactory.getInstance("RSA");
			PublicKey publicKey = keyFactory.generatePublic(x509EncodedKeySpec);
			cipher = Cipher.getInstance("RSA");
			cipher.init(Cipher.DECRYPT_MODE, publicKey);
			result = cipher.doFinal(result);
			System.out.println("私钥加密、公钥解密——解密：" + new String(result));
			
			//4.公钥加密、私钥解密——加密
			x509EncodedKeySpec = new X509EncodedKeySpec(rsaPublicKey.getEncoded());
			keyFactory = KeyFactory.getInstance("RSA");
			publicKey = keyFactory.generatePublic(x509EncodedKeySpec);
			cipher = Cipher.getInstance("RSA");
			cipher.init(Cipher.ENCRYPT_MODE, publicKey);
			result = cipher.doFinal(src.getBytes());
			System.out.println("公钥加密、私钥解密——加密 : " + Base64.encodeBase64String(result));
			
			//5.公钥加密、私钥解密——解密
			pkcs8EncodedKeySpec = new PKCS8EncodedKeySpec(rsaPrivateKey.getEncoded());
			keyFactory = KeyFactory.getInstance("RSA");
			privateKey = keyFactory.generatePrivate(pkcs8EncodedKeySpec);
			cipher = Cipher.getInstance("RSA");
			cipher.init(Cipher.DECRYPT_MODE, privateKey);
			result = cipher.doFinal(result);
			System.out.println("公钥加密、私钥解密——解密：" + new String(result));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

}
